using Indotalent.Data.Entities;
using Indotalent.Shared.Consts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Indotalent.Infrastructure.Database.MsSQL.Configuration;

public class SalesRepresentativeConfiguration : IEntityTypeConfiguration<SalesRepresentative>
{
    public void Configure(EntityTypeBuilder<SalesRepresentative> builder)
    {
        builder.Property(e => e.Name)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.AutoNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.JobTitle)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.EmployeeNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.PhoneNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.EmailAddress)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Description)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.SalesTeamId)
            .HasMaxLength(GlobalConsts.StringLengthId);

        builder.HasOne(e => e.SalesTeam)
            .WithMany()
            .HasForeignKey(e => e.SalesTeamId)
            .OnDelete(DeleteBehavior.NoAction);

        builder.HasIndex(e => new { e.TenantId, e.Name }).IsUnique();
        builder.HasIndex(e => new { e.TenantId, e.AutoNumber }).IsUnique();
        builder.HasIndex(e => e.SalesTeamId);
    }
}